namespace GamesStore.DataProviders.GamesDbMigrations
{
    using System;
    using System.Data.Entity.Migrations;
    
    public partial class DevelopersInStudiosAdded : DbMigration
    {
        public override void Up()
        {
            DropForeignKey("dbo.Games", "Studio_Id", "dbo.Studios");
            DropPrimaryKey("dbo.Developers");
            DropPrimaryKey("dbo.Games");
            DropPrimaryKey("dbo.Studios");
            AddColumn("dbo.Developers", "Studio_Id", c => c.Guid());
            AlterColumn("dbo.Developers", "Id", c => c.Guid(nullable: false, identity: true, defaultValueSql: "NEWID()"));
            AlterColumn("dbo.Games", "Id", c => c.Guid(nullable: false, identity: true, defaultValueSql: "NEWID()"));
            AlterColumn("dbo.Studios", "Id", c => c.Guid(nullable: false, identity: true, defaultValueSql: "NEWID()"));
            AddPrimaryKey("dbo.Developers", "Id");
            AddPrimaryKey("dbo.Games", "Id");
            AddPrimaryKey("dbo.Studios", "Id");
            CreateIndex("dbo.Developers", "Studio_Id");
            AddForeignKey("dbo.Developers", "Studio_Id", "dbo.Studios", "Id");
            AddForeignKey("dbo.Games", "Studio_Id", "dbo.Studios", "Id");
        }
        
        public override void Down()
        {
            DropForeignKey("dbo.Games", "Studio_Id", "dbo.Studios");
            DropForeignKey("dbo.Developers", "Studio_Id", "dbo.Studios");
            DropIndex("dbo.Developers", new[] { "Studio_Id" });
            DropPrimaryKey("dbo.Studios");
            DropPrimaryKey("dbo.Games");
            DropPrimaryKey("dbo.Developers");
            AlterColumn("dbo.Studios", "Id", c => c.Guid(nullable: false));
            AlterColumn("dbo.Games", "Id", c => c.Guid(nullable: false));
            AlterColumn("dbo.Developers", "Id", c => c.Guid(nullable: false));
            DropColumn("dbo.Developers", "Studio_Id");
            AddPrimaryKey("dbo.Studios", "Id");
            AddPrimaryKey("dbo.Games", "Id");
            AddPrimaryKey("dbo.Developers", "Id");
            AddForeignKey("dbo.Games", "Studio_Id", "dbo.Studios", "Id");
        }
    }
}
