﻿using GamesStore.Entities;
using System;
using System.Linq;

namespace GamesStore.Repository
{
    public static class GameQueryableExtensions
    {
        public static IQueryable<Game> FilterByGenre(this IQueryable<Game> games, string filter)
        {
            if (filter == null)
            {
                return games;
            }

            if (games == null)
            {
                throw new ArgumentNullException(nameof(games));
            }

            var genres = filter.Split(';')
               .Select(s => Enum.Parse(typeof(GameGenreEnum), s))
               .Cast<GameGenreEnum>();

            return games.Where(g => genres.Contains(g.Genre));
        }
    }
}
