﻿using System.Collections.Generic;
using System.Data.Entity;
using System.Threading.Tasks;

using GamesStore.Entities;
using GamesStore.DataProviders;


namespace GamesStore.Repository
{
    public class GamesService
    {
        private GamesDbContext _dbContext;

        public GamesService(GamesDbContext dbContext)
        {
            _dbContext = dbContext;
        }

        public async Task<IEnumerable<Game>> GetGamesByGenreAsync(string filter)
        {
            IEnumerable<Game> games = await _dbContext.Games
                    .FilterByGenre(filter)
                    .ToListAsync();
           
            return games;
        }
    }
}
